# Captain nel
#---------------------------------------------------------------------------------------------
#executed from : execute as @e[tag=nel_Entity,type=iron_golem] at @s run
execute if entity @s[tag=!scened] run function ampsurv:entity/ally/hero/nel/scening

#Attacking
function ampsurv:entity/ally/hero/nel/attack

#walking
execute if entity @s[tag=!attack] run function ampsurv:entity/ally/hero/nel/movement

# model manager ----------

effect give @s invisibility 999999 0 true
execute unless entity @e[tag=nel_Model,distance=..2] run function jekk:summon/nel
execute unless entity @e[tag=nel_name,distance=..3] run summon armor_stand ~ ~2 ~ {NoGravity:1b,Marker:1b,Invisible:true,CustomName:'[{"text":"Arbiter Knight Nel","bold":true,"color":"red"}]',CustomNameVisible:1b,Tags:["nel_name"]}
execute as @e[tag=nel_Model,type=marker,limit=1,sort=nearest] at @s run tp @e[tag=nel_name,limit=1,sort=nearest] ~ ~2 ~

execute as @s[tag=nel_Entity,type=iron_golem] at @s run tp @e[tag=nel_Model,sort=nearest,limit=1] ^ ^ ^-0.1 facing entity @s

execute as @e[tag=nel_Model,type=marker,limit=1,sort=nearest] at @s unless entity @e[tag=nel_Entity,type=iron_golem,distance=..2] run function jekk:remove/this

execute unless entity @e[tag=nel_dd] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["nel_dd","hero_dd"]}

#greets
execute as @e[tag=nel_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=0..10}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Nel","bold":true,"color":"green"},{"text":"> Let's stay vigilant, ","color":"white"},{"selector":"@p","color":"white"},{"text":" !","color":"white"}]
execute as @e[tag=nel_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=11..20}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Nel","bold":true,"color":"green"},{"text":"> How's your day been, ","color":"white"},{"selector":"@p","color":"white"},{"text":" ?","color":"white"}]
execute as @e[tag=nel_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=21..30}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Captain Nel","bold":true,"color":"green"},{"text":"> Report to me if you catch anything out of the ordinary, ","color":"white"},{"selector":"@p","color":"white"},{"text":" !","color":"white"}]
execute as @s[tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tp @s ~ ~ ~ facing entity @p[distance=..4,limit=1,gamemode=!spectator]
execute as @s[tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run effect give @s slowness 1 255 true
execute as @s[tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run execute as @e[tag=nel_Model,limit=1,sort=nearest] run function ampsurv:entity/ally/hero/nel/anim-reset
#execute as @e[tag=nel_Entity,type=iron_golem,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run execute as @e[tag=nel_Model,limit=1,sort=nearest] run function nel:animations/skill/play
execute as @s[tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tag @s add greeted_player
execute unless entity @e[type=#enemy,distance=..20] unless entity @p[distance=..10] run tag @s remove greeted_player

#hurt
execute as @s[tag=nel_Entity,type=iron_golem,tag=hurt] at @s run playsound entity.generic.hurt neutral @a[distance=..5] ~ ~ ~ 1 1 0
execute as @s[tag=nel_Entity,type=iron_golem,tag=hurt] at @s run particle angry_villager ~ ~1.5 ~ 0.3 0.3 0.3 0 3 normal

#dod and particles and effects
execute as @e[tag=nel_Entity,type=iron_golem,tag=hurt,nbt=!{ActiveEffects:[{Id:22b}]}] at @s if entity @p[scores={ally.anim_tick=5..10}] run function ampsurv:entity/ally/hero/nel/nel-skill
execute as @e[tag=nel_Entity,type=iron_golem,nbt={ActiveEffects:[{Id:22b}]}] at @s run particle minecraft:witch ~ ~0.4 ~ 0.2 0.4 0.2 0 15 normal

#midland tps
execute as @e[tag=greet_cd_nel] at @s if entity @p[tag=host,distance=30.., sort=nearest,limit=1] run tp @s @a[tag=host,limit=1,sort=nearest]
execute as @e[tag=nel_Entity,type=iron_golem] at @s if entity @a[tag=host,distance=30.., sort=nearest,limit=1] run kill @e[tag=nel_dd]
execute as @e[tag=nel_Entity,type=iron_golem] at @s if entity @p[tag=host,distance=30.., sort=nearest,limit=1] run tp @s @a[tag=host,limit=1,sort=nearest]
