#Targetting Checks
function ampsurv:system/entity-manager

#WTC updates
scoreboard players add worldScore wtc_20 1
scoreboard players add worldScore wtc_4 1
scoreboard players add worldScore wtc_10 1

execute if score worldScore wtc_20 matches 20.. run scoreboard players set worldScore wtc_20 0
execute if score worldScore wtc_4 matches 4.. run scoreboard players set worldScore wtc_4 0
execute if score worldScore wtc_10 matches 10.. run scoreboard players set worldScore wtc_10 0

#Boss Checks
function ampsurv:boss/bossbars/driver
execute if entity @e[tag=boss] run function md:md-bossmanager
function ampsurv:boss/a_tick

#registration checks
execute if score worldScore wtc_20 matches 19.. if entity @p[tag=!registerred] run execute as @a[tag=!registerred] run function ampsurv:scoreboards/this-player

# Skill Checks
function ampsurv:skill-tick

#Relic Proccs
function ampsurv:relic/check-proccs

#Utility Checks
execute if score worldScore wtc_4 matches 3.. run function ampsurv:system/util/tick-check

#Landmark Checks
execute if score worldScore wtc_10 matches 9.. if entity @e[tag=bosstotem,type=armor_stand] run function ampsurv:landmarks/bosstotem/bosstotems
execute as @a[tag=creative_shock] at @s unless entity @e[tag=bosstotem,distance=..50] run tag @s remove creative_shock

#Custom Allies Checks
function ampsurv:entity/ally/check

#Enemies Checks
function ampsurv:entity/enemy/check

#voting checks
function ampsurv:system/voting/generic-driver

#Structures Check
execute if entity @e[tag=structure] run function ampsurv:structures/ally/structure_driver

#Carrot on a stick check
execute as @a[predicate=ampsurv:hold_carrot_stick,predicate=!ampsurv:offhand_carrot_stick] run function ampsurv:system/emerald_pouch/emerald_pouch_driver
execute as @a[predicate=ampsurv:offhand_carrot_stick,predicate=!ampsurv:hold_carrot_stick] run function ampsurv:system/emerald_pouch/emerald_pouch_driver
#staff
execute as @a[predicate=ampsurv:hold_carrot_stick] run function ampsurv:weapons/staff/manager
execute if score worldScore wtc_4 matches 3.. run tag @a[tag=holding_staff] remove holding_staff
#manage staff projectiles
function ampsurv:weapons/staff/projectile-manager

#Holding nothing check
execute as @a[predicate=ampsurv:holding_nothing] run function ampsurv:system/direction

#alchemy tick
function ampsurv:system/alchemy_table/check

#compass check
function ampsurv:items/compass/driver

#global score resets
scoreboard players set @a use_carrot_stick 0
scoreboard players set @a crouch 0