# Trigger
execute as @a[tag=host,tag=trigger_act3] at @s run tag @a add playing_act3
function midland:system-act-playercounter

#Set Checkpoint
spawnpoint @a[tag=playing_act3] -80 27 410

#Dialogue
scoreboard players set @a mlDialogueTimer 0

#Title
title @a[tag=playing_act3] title {"text":"Act III","color":"aqua","bold":false,"font":"minecraft:dwarvesc"}
title @a[tag=playing_act3] subtitle {"text":"Passage to Deliverance","color":"aqua","bold":false}

#Reset Assets
kill @e[type=#enemy,tag=objective]
kill @e[tag=mission_ally]

#Spawn Assets
#- Enemies - 
execute at @e[tag=chapel_spawn] run summon minecraft:bat ~ ~ ~ {CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Mystic Bat","color":"dark_purple","bold":false}]',Health:100,FallFlying:1b,NoAI:1b,Tags:["mystic_bat","need_clear"],NoGravity:1b,Attributes:[{Name:"generic.max_health",Base:100F}],Passengers:[{id:witch,CustomName:'[{"text":"Lv.1 ","bold":true,"color":"aqua"},{"text":"Necromancer","bold":false,"color":"dark_purple"}]',Health:50,Tags:["objective","enemy","necromancer"],Attributes:[{Name:"generic.armor",Base:10f},{Name:"generic.knockback_resistance",Base:1f},{Name:"generic.max_health",Base:50F}]}]}
execute at @e[tag=chapel_spawn] run summon minecraft:zombie_horse ~ ~ ~ {Tame:1,CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Zombie Horse","color":"dark_red","bold":false}]',Health:50,PersistenceRequired:1b,Attributes:[{Name:"generic.movement_speed",Base:0.2f},{Name:"generic.max_health",Base:50F}],Passengers:[{id:zombie,CustomName:'[{"text":"Lv.1","bold":true,"color":"aqua"},{"text":" ","bold":false},{"text":"Dead Knight","bold":false,"color":"dark_red"}]',Health:30,PersistenceRequired:1b,HandItems:[{id:iron_sword,tag:{Enchantments:[{id:power,lvl:3},{id:punch,lvl:2}]},Count:1},{id:shield,Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:leather_boots,tag:{Unbreakable:1,display:{color:1908001}},Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.max_health",Base:30F}]}]}
execute at @e[tag=chapel_spawn] run summon minecraft:zombie_horse ~ ~ ~ {Tame:1,CustomName:'[{"text":"Lv.1","color":"aqua","bold":true},{"text":" Zombie Horse","color":"dark_red","bold":false}]',Health:50,PersistenceRequired:1b,Attributes:[{Name:"generic.movement_speed",Base:0.2f},{Name:"generic.max_health",Base:50F}],Passengers:[{id:zombie,CustomName:'[{"text":"Lv.1","bold":true,"color":"aqua"},{"text":" ","bold":false},{"text":"Dead Knight","bold":false,"color":"dark_red"}]',Health:30,PersistenceRequired:1b,HandItems:[{id:iron_sword,tag:{Enchantments:[{id:power,lvl:3},{id:punch,lvl:2}]},Count:1},{id:shield,Count:1}],HandDropChances:[0.00f,0.00f],ArmorItems:[{id:leather_boots,tag:{Unbreakable:1,display:{color:1908001}},Count:1},{id:iron_leggings,Count:1},{id:iron_chestplate,Count:1},{id:iron_helmet,Count:1}],ArmorDropChances:[0.00f,0.00f,0.00f,0.00f],Attributes:[{Name:"generic.follow_range",Base:100f},{Name:"generic.max_health",Base:30F}]}]}
#Reset bosstotem
tag @e[tag=summoned,tag=astaroth_totem] remove summoned
# Reset Commentaries
tag @e remove commented_on_zerr_passage
tag @e remove commented_on_rck

#set Objectives
execute at @e[tag=act3_start_totem] run setblock ~ ~ ~ redstone_block
tellraw @a ["",{"text":"-------------- Act III --------------","bold":true,"color":"green"},{"text":"\n"},{"text":"Area : Fields of Astaria","color":"light_purple"},{"text":"\nObjectives:\n - Kill the Necromancer in the Chapel.\n - Defeat Astaroth, the Lich King inside the Ruined Castle of Astaria\n "}]

#Reset Trigger
execute as @a[tag=host,tag=playing_act3,tag=trigger_act3] at @s run tag @s remove trigger_act3
